/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20141107-64 [Jan  2 2015]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-1.aml, Sat Jan  2 15:36:39 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000004C1 (1217)
 *     Revision         0x01
 *     Checksum         0xD0
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "INSYDE  "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT-1.aml", "SSDT", 1, "HPQOEM", "INSYDE  ", 0x00001000)
{

    External (_SB_.PCI0.LPCB.EC0_.AAEN, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.AAEW, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.AAND, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.AARW, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.AASD, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.AAST, FieldUnitObj)
    External (_SB_.PCI0.LPCB.RTC_.RTCH, FieldUnitObj)
    External (_SB_.PCI0.LPCB.RTC_.RTCM, FieldUnitObj)
    External (_SB_.PCI0.LPCB.RTC_.RTCS, FieldUnitObj)
    External (AOAC, FieldUnitObj)
    External (GP45, FieldUnitObj)

    Scope (\_SB)
    {
        Device (IAOE)
        {
            Name (_HID, "INT33A0")  // _HID: Hardware ID
            Name (_UID, Zero)  // _UID: Unique ID
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\_SB.PCI0.LPCB.EC0.AAEN, One))
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Name (AOS1, Zero)
            Name (ANS1, Zero)
            Name (WLS1, One)
            Name (WWS1, One)
            Name (ASDS, Zero)
            Name (ECWM, Zero)
            Name (ISCS, Zero)
            Name (ISCM, Zero)
            Name (ISCH, Zero)
            Name (PRTS, Zero)
            Name (PRTM, Zero)
            Name (PRTH, Zero)
            Method (GABS, 0, NotSerialized)
            {
                Or (AOAC, 0x30, AOAC)
                And (AOAC, 0x3F, AOAC)
                If (LEqual (And (AOAC, 0x04), 0x04))
                {
                    Store (One, WLS1)
                }
                Else
                {
                    Store (Zero, WLS1)
                }

                If (LEqual (And (AOAC, 0x08), 0x08))
                {
                    Store (One, WWS1)
                }
                Else
                {
                    Store (Zero, WWS1)
                }

                Return (AOAC)
            }

            Method (GAOS, 0, NotSerialized)
            {
                Return (AOS1)
            }

            Method (SAOS, 1, NotSerialized)
            {
                If (LEqual (And (Arg0, One), One))
                {
                    Store (One, AOS1)
                    Store (Zero, \_SB.PCI0.LPCB.EC0.AAEW)
                }
                Else
                {
                    Store (Zero, AOS1)
                    Store (Zero, \_SB.PCI0.LPCB.EC0.AAST)
                }
            }

            Method (GANS, 0, NotSerialized)
            {
                Return (ANS1)
            }

            Method (SANS, 1, NotSerialized)
            {
                If (LEqual (And (Arg0, One), One))
                {
                    Store (One, ANS1)
                }
                Else
                {
                    Store (Zero, ANS1)
                }
            }

            Method (GWLS, 0, NotSerialized)
            {
                If (LEqual (GP45, One))
                {
                    Or (WLS1, One, WLS1)
                }
                Else
                {
                    And (WLS1, 0xFE, WLS1)
                }

                Return (WLS1)
            }

            Method (SWLS, 1, NotSerialized)
            {
                Store (And (Arg0, 0xFE), Local0)
                Store (And (WLS1, One), WLS1)
                Store (Or (Local0, WLS1), WLS1)
                If (LOr (LEqual (And (WLS1, 0x02), 0x02), LEqual (And (WLS1, 0x04
                    ), 0x04)))
                {
                    Store (One, \_SB.PCI0.LPCB.EC0.AAND)
                }
                Else
                {
                    Store (Zero, \_SB.PCI0.LPCB.EC0.AAND)
                }
            }

            Method (GWWS, 0, NotSerialized)
            {
                Return (WWS1)
            }

            Method (SWWS, 1, NotSerialized)
            {
                Store (And (Arg0, 0xFE), Local0)
                Store (And (WWS1, One), WWS1)
                Store (Or (Local0, WWS1), WWS1)
            }

            Method (SASD, 1, NotSerialized)
            {
                Store (Arg0, ASDS)
                If (LEqual (ShiftRight (ASDS, 0x1F), One))
                {
                    Store (FromBCD (\_SB.PCI0.LPCB.RTC.RTCH), PRTH)
                    Store (ShiftRight (ASDS, 0x0C), ISCH)
                    Store (And (ISCH, 0x1F), ISCH)
                    If (LGreater (PRTH, ISCH))
                    {
                        Add (ISCH, 0x18, ISCH)
                    }

                    Subtract (ISCH, PRTH, ISCH)
                    Multiply (ISCH, 0x3C, ECWM)
                    Store (FromBCD (\_SB.PCI0.LPCB.RTC.RTCM), PRTM)
                    Store (ShiftRight (ASDS, 0x06), ISCM)
                    Store (And (ISCM, 0x3F), ISCM)
                    If (LGreater (PRTM, ISCM))
                    {
                        Subtract (ECWM, 0x3C, ECWM)
                        Add (ISCM, 0x3C, ISCM)
                    }

                    Subtract (ISCM, PRTM, ISCM)
                    Add (ECWM, ISCM, ECWM)
                    Store (FromBCD (\_SB.PCI0.LPCB.RTC.RTCS), PRTS)
                    Store (And (ASDS, 0x3F), ISCS)
                    If (LGreater (PRTS, ISCS))
                    {
                        Subtract (ECWM, One, ECWM)
                        Add (ISCS, 0x3C, ISCS)
                    }

                    Subtract (ISCS, PRTS, ISCS)
                    If (LGreaterEqual (ISCS, 0x1E))
                    {
                        Add (ECWM, One, ECWM)
                    }

                    Store (ECWM, \_SB.PCI0.LPCB.EC0.AASD)
                }
                Else
                {
                    Divide (ASDS, 0x3C, Local0, ECWM)
                    If (LGreaterEqual (Local0, 0x1E))
                    {
                        Add (ECWM, One, ECWM)
                    }

                    Store (ECWM, \_SB.PCI0.LPCB.EC0.AASD)
                }
            }

            Method (GPWR, 0, NotSerialized)
            {
                If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.AAEW, One), LEqual (\_SB.PCI0.LPCB.EC0.AAND, Zero)))
                {
                    Return (0x12)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.LPCB.EC0.AARW, One))
                    {
                        Return (0x04)
                    }
                    Else
                    {
                        If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.AAEW, One), LEqual (\_SB.PCI0.LPCB.EC0.AAND, One)))
                        {
                            Return (0x08)
                        }
                        Else
                        {
                            Return (One)
                        }
                    }
                }
            }
        }
    }
}

